#!/usr/bin/perl

package Mooix::Verb;

#Turn off in production code!
#use strict;
#use warnings;

=head1 NAME

Mooix::Verb - module for verb methods

=head1 SYNOPSIS

  use Mooix::Verb;

=head1 DESCRIPTION

This module provides some stuff that might be useful for verb methods.

=cut

=head1 CONSTANTS

The following constants are provided (but are not exported). A method
may exit with the constant to communicate with the parser. See the
online documentation on L<=verbs=> for details.

=over 4

=item FAIL

Note that it's better to use the fail function provided by Mooix::Thing.

=item SKIP

=item EXIT

=item SETIT

=item SETITREF

=back

=cut

use constant {
	FAIL => 10,
	SKIP => 20,
	EXIT => 30,
	SETIT => 40,
	SETITREF => 50,
};

=head1 COPYRIGHT

Copyright 2001-2003 by Joey Hess <joey@mooix.net>
under the terms of the modified BSD license given in full in the file
COPYRIGHT.

=head1 AUTHOR

Joey Hess <joey@mooix.net>

=cut

1
