#include <string.h>
#include <sys/file.h>
#include <stdio.h>
#include <stdlib.h>
#include <moomethod.h>

void onchange () {
	char *file, *onchange;

	file = fieldfile(getobj("."), "onchange");
	if (! file)
		return;

	onchange = getfield(file);
	if (onchange) {
		runmethod(getobj("owner"), onchange, NULL);
	}
}
	
int main (int argc, char **argv) {
	param *p;
	object *obj = NULL;
	FILE *f;
	
	methinit();
	while ((p = getparam())) {
		if (strcmp(p->name, "object") == 0) {
			obj = derefobj(p->value);
		}
	}
	
	if (! obj) {
		fprintf(stderr, "object field required\n");
		exit(1);
	}

	f = fopen("list", "a");
	if (! f) {
		perror("open list");
		exit(1);
	}

	/* lock to guard against races */
	if (flock(fileno(f), LOCK_EX) != 0) {
		perror("flock");
		exit(1);
	}

	fprintf(f, "mooix:%s\n", obj->dir);
	fclose(f);

	onchange();
	
	printf("mooix:%s\n", obj->dir);
	exit(0);
}
