#include <stdio.h>
#include <moomethod.h>
#include <sys/file.h>

#include "socket.c"

int main (int argc, char **argv) {
	param *p;
	char *prompt = "";
	FILE *f, *meth;
	char *input, *ret;
	int l;
	
	methinit();

	/* Parse parameters for "prompt". */
	while ((p = getparam())) {
		if (strcmp(p->name, "prompt") == 0) {
			prompt = p->value;
		}
		else {
			freeparam(p);
		}
	}
	
	f = setupsocket();
	fprintf(f, "p\n");
	
	/* Is this a safe or unsafe password request? */
	meth = runmethod(getobj("."), "safepassword", NULL);
	if (! meth) {
		perror("cannot run safepassword");
		exit(1);
	}
	ret = fgetvalue(meth);
	fclose(meth);
	if (ret && atoi(ret) == 1)
		fprintf(f, "1\n");
	else
		fprintf(f, "0\n");

	fprintf(f, "%s\n", prompt);
	fflush(f);
	shutdown(fileno(f), SHUT_WR);
	input = mooix_getline(f, 0);
	printf("%s\n", escape(input));
	exit(0);
}
